
#ifndef CHATLINE_HPP
#define CHATLINE_HPP

#include <string>
#include <map>


using std::string;
using std::map;


/**
Chat content, parser and formatter.
A chat is sent in the format

command=login&username=petar&password=lozinka
**/
class chat_line
{
private:

	map<string, string> _params;
	
public:

	static const string PARAM_SEP;
	
	static const string NAME_VALUE_SEP;
	
	static const string WHITESPACES;

	chat_line();

	string get_command();

	void set_command(string cmd);

	string get_username();

	void set_username(string user);
	
	string get_password();

	void set_password(string pass);
	
	void set_to(string t);

	string get_to();

	void set_from(string f);

	string get_from();

	void set_chat_line(string line);
	
	string get_chat_line();

	bool empty();
	
	string to_string();

	bool parse(string request);
	
	string format();
	
	static string trim(string str);
};

#endif // CHATLINE_HPP