
#include <cassert>
#include "message.hpp"


using boost::shared_ptr;


shared_ptr<message> message::create(shared_ptr<ip::tcp::socket> socket)
{
	shared_ptr<message> msg(new message);
	msg->set_session(shared_ptr<session>(new session(socket)));
	return msg;
}


shared_ptr<message> message::create(shared_ptr<ip::tcp::socket> socket, shared_ptr<chat_line> line)
{
	shared_ptr<message> msg(new message);
	msg->set_session(shared_ptr<session>(new session(socket)));
	msg->set_chat_line(line);
	return msg;
}


void message::destroy(shared_ptr<message> msg)
{
}


shared_ptr<session> message::get_session()
{
	return _session;
}


void message::set_session(shared_ptr<session> s)
{
	_session = s;
}


shared_ptr<chat_line> message::get_chat_line()
{
	return _chat_line;
}


void message::set_chat_line(shared_ptr<chat_line> line)
{
	_chat_line = line;
}
