
#ifndef MESSAGE_HPP
#define MESSAGE_HPP

#include "session.hpp"
#include "chat_line.hpp"


using namespace boost::asio;
using boost::shared_ptr;


/**
Stores chat content and session status.
Only one message/session exist for a particular socket.
**/
class message
{
public:

	static shared_ptr<message> create(shared_ptr<ip::tcp::socket> socket);

	static shared_ptr<message> create(shared_ptr<ip::tcp::socket> socket, shared_ptr<chat_line> line);

	static void destroy(shared_ptr<message> msg);

	shared_ptr<session> get_session();

	void set_session(shared_ptr<session> a_session);

	shared_ptr<chat_line> get_chat_line();

	void set_chat_line(shared_ptr<chat_line> line);

private:

	shared_ptr<session> _session;

	shared_ptr<chat_line> _chat_line;
};

#endif // MESSAGE_HPP